using System;
using Cute;

namespace Wizard;

public class Matching_Sealed : Matching
{
	public Matching_Sealed()
	{
		errorDialogReturnText = Data.SystemText.Get("Sealed_BattleResult_0001");
	}

	public override void DoMatching(Action onFinished, int need_init, DO_MATCHING_LOG log)
	{
		base.DoMatching(onFinished, need_init, log);
		SealedBattleDoMatchingTask task = new SealedBattleDoMatchingTask(selectDeckID, need_init, (int)log);
		ConnectAPI(task, delegate
		{
			if (Data.DoMatchingDetail.data.matchingState != 3009)
			{
				DoMatchingResultSetting();
				onFinished.Call();
			}
		});
	}

	protected override void TimeOutMessageToRetry()
	{
		SystemText systemText = Data.SystemText;
		ErrorDialogWithRetry(systemText.Get("Battle_0461"), systemText.Get("Battle_0412"));
	}

	public override FinishTaskBase GetBattleFinishTask()
	{
		return new SealedBattleFinishTask();
	}

	protected override void GotoDeckSelectScene()
	{
		UIManager uiMgr = UIManager.GetInstance();
		UIManager.ChangeViewSceneParam param = new UIManager.ChangeViewSceneParam
		{
			OnFinishChangeView = delegate
			{
				uiMgr.CloseInSceneLoadingMatching();
				uiMgr.CloseInSceneLoadingBattle();
			}
		};
		uiMgr.ChangeViewScene(UIManager.ViewScene.Sealed, param);
	}
}
